## seetaface-landmarker 1.0.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(SeetaFaceLandmarker_NAME "SeetaFaceLandmarker" CACHE STRING "The SeetaFaceLandmarker library name")
set(SeetaFaceLandmarker_VERSION_MAJOR "6")
set(SeetaFaceLandmarker_VERSION_MINOR "0")
set(SeetaFaceLandmarker_VERSION_SINOR "0")
set(SeetaFaceLandmarker_VERSION "${SeetaFaceLandmarker_VERSION_MAJOR}${SeetaFaceLandmarker_VERSION_MINOR}${SeetaFaceLandmarker_VERSION_SINOR}")
project(${SeetaFaceLandmarker_NAME}${SeetaFaceLandmarker_VERSION})
# set(CMAKE_VERBOSE_MAKEFILE on)

set(SOLUTION_DIR ${CMAKE_CURRENT_SOURCE_DIR})

# option for shared or static
set(TARGET "SHARED" CACHE STRING "SHARED or STATIC" FORCE)
# option for SeetaAuthorize
option(SEETA_AUTHORIZE "Using seeta authorize" OFF)
option(SEETA_MODEL_ENCRYPT "Using model encrypt" ON)
# option for build android
option(BUILD_ANDROID "Buid android" OFF)
message(STATUS "Build android: " ${BUILD_ANDROID})

# gether moduls
list(APPEND CMAKE_MODULE_PATH ${SOLUTION_DIR}/../build/cmake)
list(APPEND CMAKE_MODULE_PATH ${SOLUTION_DIR}/cmake)
message(STATUS "CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")

# install dir
set(CMAKE_INSTALL_PREFIX ${SOLUTION_DIR}/../build CACHE STRING "set install prefix" FORCE)
set(SEETA_INSTALL_PATH "" CACHE STRING "seeta install path")
if(SEETA_INSTALL_PATH STREQUAL "")
else()
	set(CMAKE_INSTALL_PREFIX ${SEETA_INSTALL_PATH} CACHE STRING "set install prefix" FORCE)
endif()
message(STATUS "cmake install prefix: ${CMAKE_INSTALL_PREFIX}")

# set base flags
set(CMAKE_CFLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden -w")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -w -std=c++11")

# option for platform
set(PLATFORM "auto" CACHE STRING "auto, x86 or x64")
set(CONFIGURATION "Release" CACHE STRING "Debug or Release")

# env
include(LOCAL_ENV)
include(INC_ORZ)

if(SEETA_AUTHORIZE)
	add_definitions(-DSEETA_AUTO_ENCRYPT)
	message(STATUS "Seeta Authorize: ON")
else()
	message(STATUS "Seeta Authorize: OFF")
endif()

if(SEETA_MODEL_ENCRYPT)
	add_definitions(-DSEETA_MODEL_ENCRYPT)
	message(STATUS "Seeta Model Encrypt: ON")
else()
	message(STATUS "Seeta Model Encrypt: OFF")
endif()

if(SEETA_AUTHORIZE)
	message(STATUS "SeetaAuthorize: " ${SEETA_AUTHORIZE})
elseif()
endif ()

if (SEETA_MODEL_ENCRYPT)
   message(STATUS "SeetaModelEncrypt: " ${SEETA_MODEL_ENCRYPT})
endif ()

if ("${PLATFORM}" STREQUAL "x86")
    message(STATUS "Platform: " ${PLATFORM})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
elseif ("${PLATFORM}" STREQUAL "x64")
    message(STATUS "Platform: " ${PLATFORM})
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m64")
else()
	message(STATUS "Platform: " ${PLATFORM})
endif()

if ("${CONFIGURATION}" STREQUAL "Debug")
    message(STATUS "Configuration: " ${CONFIGURATION})
    set(CMAKE_CX_FLAGS "${CMAKE_CX_FLAGS} -O0 -g -ggdb")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g -ggdb")
else()
    message(STATUS "Configuration: " ${CONFIGURATION})
    set(CMAKE_CX_FLAGS "${CMAKE_CX_FLAGS} -O3")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
endif()

add_subdirectory(${SOLUTION_DIR}/Landmarker)
if(NOT BUILD_ANDROID)
	#add_subdirectory(${SOLUTION_DIR}/example)
endif()

=== Landmarker/CMakeLists.txt ===
# library in subdir

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")

add_definitions(-DSEETA_EXPORTS)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include/seeta)

#configure library version and name
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/${SeetaFaceLandmarker_NAME}Config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/${SeetaFaceLandmarker_NAME}Config.h @ONLY)

file(GLOB_RECURSE ROOT_SRC_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/src/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp
    )
	
	
file(GLOB_RECURSE COMMON_INCLUDE_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/Common/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/Common/*.hh
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/Common/*.hpp
	)

file(GLOB_RECURSE ROOT_SEETA_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/seeta/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/seeta/*.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/seeta/*.cpp
    )

file(GLOB INCLUDE_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/*.hh
    ${CMAKE_CURRENT_SOURCE_DIR}/include/seeta/*.hpp
    )

list(APPEND SRC_FILES ${ROOT_SRC_FILES})
list(APPEND SRC_FILES ${ROOT_SEETA_FILES})

# add library
add_library(${PROJECT_NAME} ${TARGET} ${SRC_FILES})

# link SeetaAuthorize
if(SEETA_AUTHORIZE)
	find_package(SeetaAuthorize REQUIRED)
	include_directories(${SeetaAuthorize_INCLUDE_DIRS})
	target_link_libraries(${PROJECT_NAME} ${SeetaAuthorize_LIBRARIES})
endif()

if(SEETA_MODEL_ENCRYPT)
	find_package(SeetaAuthorize REQUIRED)
	include_directories(${SeetaAuthorize_INCLUDE_DIRS})
	target_link_libraries(${PROJECT_NAME} ${SeetaAuthorize_LIBRARIES})
endif()


# more link library
find_package(TenniS REQUIRED)
include_directories(${TenniS_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} ${TenniS_LIBRARIES})

# link ORZ
target_link_libraries(${PROJECT_NAME} ORZ_static${ENV_SUFFIX})

# set library properties
if ("${CONFIGURATION}" STREQUAL "Debug")
    set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME}d)
else()
    set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
endif()

# build dir
set(OUT_DIR ${SOLUTION_DIR}/build)

#create install dir
file(MAKE_DIRECTORY ${OUT_DIR})

set(LIBRARY_OUTPUT_PATH ${OUT_DIR}/${ENV_LIBRARY_DIR})
set(ARCHIVE_OUTPUT_PATH ${OUT_DIR}/${ENV_LIBRARY_DIR})
# add command to copy header files
add_custom_command(TARGET ${PROJECT_NAME}
        PRE_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUT_DIR}/${ENV_INCLUDE_DIR}
        )
add_custom_command(TARGET ${PROJECT_NAME}
        PRE_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUT_DIR}/${ENV_INCLUDE_DIR}/seeta
        )

add_custom_command(TARGET ${PROJECT_NAME}
        PRE_BUILD
        COMMAND ${CMAKE_COMMAND} -E make_directory ${OUT_DIR}/${ENV_INCLUDE_DIR}/seeta/Common
        )
# copy every header files
foreach(header ${INCLUDE_FILES})
    add_custom_command(TARGET ${PROJECT_NAME}
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_if_different ${header} ${OUT_DIR}/${ENV_INCLUDE_DIR}/seeta
            )
endforeach()
foreach(header ${COMMON_INCLUDE_FILES})
    add_custom_command(TARGET ${PROJECT_NAME}
            POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_if_different ${header} ${OUT_DIR}/${ENV_INCLUDE_DIR}/seeta/Common
            )
endforeach()

#install
#update and install cmake file
set(_TARGET_NAME "${SeetaFaceLandmarker_NAME}")
set(_TARGET_VERSION_MAJOR "${SeetaFaceLandmarker_VERSION_MAJOR}")
set(_TARGET_VERSION_MINOR "${SeetaFaceLandmarker_VERSION_MINOR}")
set(_TARGET_VERSION_SINOR "${SeetaFaceLandmarker_VERSION_SINOR}")
set(_TARGET_HEADER "seeta/FaceLandmarker.h")
configure_file(${SOLUTION_DIR}/cmake/FindLibrary.cmake.in ${SOLUTION_DIR}/cmake/Find${SeetaFaceLandmarker_NAME}.cmake @ONLY)

file(GLOB_RECURSE FIND_CMAKE_FILES
    ${SOLUTION_DIR}/cmake/Find${SeetaFaceLandmarker_NAME}.cmake
    )
install(FILES ${FIND_CMAKE_FILES} DESTINATION cmake)	

message(STATUS "install targets library: " ${PROJECT_NAME})

install(TARGETS ${PROJECT_NAME}
	RUNTIME DESTINATION ${ENV_RUNTIME_DIR}
	LIBRARY DESTINATION ${ENV_LIBRARY_DIR}
	ARCHIVE DESTINATION ${ENV_ARCHIVE_DIR}
)

message("destination:" ${CMAKE_INSTALL_PREFIX})
install(FILES ${COMMON_INCLUDE_FILES} DESTINATION ${ENV_INCLUDE_DIR}/seeta/Common)
install(FILES ${INCLUDE_FILES} DESTINATION ${ENV_INCLUDE_DIR}/seeta)

=== example/CMakeLists.txt ===
# test

SET(TEST_PROJECT_NAME example)

file(GLOB_RECURSE TEST_SRC_FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp
    )

add_executable(${TEST_PROJECT_NAME} ${TEST_SRC_FILES})

set(OUT_DIR ${SOLUTION_DIR}/build)

include_directories(${OUT_DIR}/${ENV_INCLUDE_DIR})

set_target_properties(${TEST_PORJECT_NAME} PROPERTIES OUTPUT_NAME ${TEST_PROJECT_NAME}${ENV_SUFFIX})

#set(EXECUTABLE_OUTPUT_PATH ${OUT_DIR}/${ENV_RUNTIME_DIR})
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_SOURCE_DIR}/${ENV_RUNTIME_DIR})

target_link_libraries(${TEST_PROJECT_NAME} ${PROJECT_NAME})

target_link_libraries(${TEST_PROJECT_NAME})

find_package(OpenCV)

find_package(SeetaFaceDetector REQUIRED)
include_directories(${SeetaFaceDetector_INCLUDE_DIRS})
target_link_libraries(${TEST_PROJECT_NAME} ${SeetaFaceDetector_LIBRARIES})



if (OpenCV_FOUND)
    include_directories(${OpenCV_INCLUDES})
    target_link_libraries(${TEST_PROJECT_NAME} ${OpenCV_LIBRARIES})
else ()
    message(WARNING "Can not find OpenCV libraries, make ${TEST_PROJECT_NAME} would failed.")
endif ()

=== debian/changelog ===
seetaface-landmarker (1.0.0.1-1+dde) UNRELEASED; urgency=medium

  * update

 -- bd <bd@seetatech.com>  Thu, 28 Apr 2022 19:25:40 +0800

seetaface-landmarker (1.0.0.1-1+dde) unstable; urgency=medium

  * Fix conflict files with seetaface-boxes

 -- chenlinxuan <chenlinxuan@uniontech.com>  Fri, 10 Dec 2021 13:33:10 +0800

seetaface-landmarker (1.0.0-1) unstable; urgency=medium

  * Initial release 

 -- liujianqing <liujianqiang@uniontech.com>  Fri, 03 Dec 2021 17:08:50 +0800

=== debian/control ===
Source: seetaface-landmarker
Section: devel
Priority: optional
Maintainer: bd <bd@seetatech.com>
Build-Depends: debhelper (>= 11),
 libopencv-dev,
 cmake,
 seetaface-open-role-zoo,
 seetaface-authorize,
 seetaface-boxes,
 seetaface-tennis
Standards-Version: 4.5.1
Homepage: https://github.com/SeetaFace6Open/Landmarker.git
Rules-Requires-Root: no

Package: seetaface-landmarker
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: landmarker for seetaface
 landmarker module for seetaface.
